=== debian/control ===
Source: khmer
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Michael R. Crusoe <michael.crusoe@gmail.com>,
           Kevin Murray <spam@kdmurray.id.au>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               dh-python,
               dh-exec,
               python3 (>= 3.3),
               python3-dev (>= 3.3),
               python3-all-dev (>= 3.3),
               python3-setuptools (>= 3.3),
               python3-screed,
               python3-nose,
               python3-sphinx,
               python3-sphinxcontrib.autoprogram,
               zlib1g-dev,
               libbz2-dev,
               asciidoctor
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/khmer.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/khmer.git
Homepage: http://khmer.readthedocs.org
X-Python-Version: 3.4

Package: khmer-common
Architecture: all
Multi-Arch: foreign
Depends: file,
         ${misc:Depends},
         ${sphinxdoc:Depends}
Description: common files for the khmer project tools
 khmer is a library and suite of command line tools for working with DNA
 sequence. It is primarily aimed at short-read sequencing data such as
 that produced by the Illumina platform. khmer takes a k-mer-centric
 approach to sequence analysis, hence the name.
 .
 This package contains common files for liboxli and khmer

Package: khmer
Architecture: amd64 any-arm64 any-mips64 any-mips64el any-ia64 any-ppc64el any-sparc64
Multi-Arch: same
Depends: khmer-common,
         python3 (>= 3.3),
         python3-screed (<< 1.0),
         ${shlibs:Depends},
         ${misc:Depends},
         ${python3:Depends}
Description: in-memory DNA sequence kmer counting, filtering & graph traversal
 khmer is a library and suite of command line tools for working with DNA
 sequence. It is primarily aimed at short-read sequencing data such as that
 produced by the Illumina platform. khmer takes a k-mer-centric approach to
 sequence analysis, hence the name.

Package: liboxli1
Architecture: amd64 any-arm64 any-mips64 any-mips64el any-ia64 any-ppc64el any-sparc64
Multi-Arch: same
Section: libs
Depends: khmer-common,
         ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: in-memory DNA sequence analysis library from the khmer project
 khmer is a library and suite of command line tools for working with DNA
 sequence. It is primarily aimed at short-read sequencing data such as that
 produced by the Illumina platform. khmer takes a k-mer-centric approach to
 sequence analysis, hence the name.
 .
 This package contains the low-level C++ library.

Package: liboxli-dev
Architecture: amd64 any-arm64 any-mips64 any-mips64el any-ia64 any-ppc64el any-sparc64
Multi-Arch: same
Section: libdevel
Depends: liboxli1 (= ${binary:Version}),
         ${misc:Depends},
         khmer-common
Description: in-memory DNA sequence analysis dev library
 khmer is a library and suite of command line tools for working with DNA
 sequence. It is primarily aimed at short-read sequencing data such as that
 produced by the Illumina platform. khmer takes a k-mer-centric approach to
 sequence analysis, hence the name.
 .
 This package contains the low-level C++ library headers and static archive.
