=== debian/changelog ===
khmer (2.0+dfsg-5) unstable; urgency=medium

  * Add 'appdata' about our IANA media type courtesy of Petter Reinholdtsen
    <pere@hungry.com>

 -- Michael R. Crusoe <crusoe@ucdavis.edu>  Fri, 05 Feb 2016 13:14:34 -0800

khmer (2.0+dfsg-4) unstable; urgency=medium

  [Michael Crusoe]
  * Put the khmer package in the 'science' section
  * Tighten arch support

  [Kevin Murray]
  * Add crunchbangs to postinst & postrm scripts

 -- Michael R. Crusoe <crusoe@ucdavis.edu>  Mon, 25 Jan 2016 05:35:34 -0800

khmer (2.0+dfsg-3) unstable; urgency=medium

  * Fixed DEP-8 test dependencies (tested with lxc instructions at
    https://ci.debian.net/doc/file.MAINTAINERS.html )

 -- Michael R. Crusoe <crusoe@ucdavis.edu>  Mon, 11 Jan 2016 11:59:11 -0800

khmer (2.0+dfsg-2) unstable; urgency=medium

  [Michael Crusoe]
  * Be explicit about architecture support
  * Set home directory for building the docs (Closes: #808424)

  [Kevin Murray]
  * Ensure that liboxli-dev depends on liboxli1

 -- Michael R. Crusoe <crusoe@ucdavis.edu>  Sun, 20 Dec 2015 01:24:57 -0800

khmer (2.0+dfsg-1) unstable; urgency=low

  * Initial upload (Closes: #777688)

 -- Michael R. Crusoe <crusoe@ucdavis.edu>  Wed, 09 Sep 2015 08:54:11 +0200
