=== debian/control ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Source: khmer
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Michael R. Crusoe <michael.crusoe@gmail.com>,
+Uploaders: Michael R. Crusoe <crusoe@ucdavis.edu>,
            Kevin Murray <spam@kdmurray.id.au>
 Section: science
 Priority: optional
@@ -17,8 +17,8 @@
                python3-sphinxcontrib.autoprogram,
                zlib1g-dev,
                libbz2-dev,
-               asciidoctor
-Standards-Version: 3.9.8
+               ruby-ronn
+Standards-Version: 3.9.6
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/khmer.git
 Vcs-Git: https://anonscm.debian.org/git/debian-med/khmer.git
 Homepage: http://khmer.readthedocs.org
