=== debian/rules ===
--- 
+++ 
@@ -19,7 +19,8 @@
 	dh_auto_build
 	ln -sf "`pwd`"/.pybuild/pythonX.Y_*/build/khmer/*.so khmer && \
 		./setup.py develop --user && ./setup.py build_sphinx
-	asciidoctor --backend manpage -a reproducible debian/khmer.1.adoc
+	ronn -r --manual=khmer --organization='khmer project' \
+		debian/khmer.1.ronn
 	cd lib && $(MAKE) clean all
 
 override_dh_auto_test:
