=== debian/tests/control ===
Tests: run-unit-test
       test-liboxli-dev
Depends: khmer,python3-nose,build-essential,zlib1g-dev,libbz2-dev,liboxli-dev
Restrictions: allow-stderr
