=== lib/Makefile ===
--- 
+++ 
@@ -150,7 +150,7 @@
 ifneq ($(PACKAGE_VERSION),)
 VERSION = $(PACKAGE_VERSION)
 else
-VERSION = $(shell ./get_version.py)
+VERSION = $(./setup.py version | grep Version | awk '{print $2}')
 endif
 
 # The ABI version of liboxli
@@ -222,9 +222,8 @@
 #### oxli proper below here ####
 
 LIBKHMER_OBJS= \
-	counting.o \
-	hashbits.o \
 	hashtable.o \
+	hashgraph.o \
 	hllcounter.o \
 	kmer_hash.o \
 	labelhash.o \
@@ -232,7 +231,11 @@
 	read_aligner.o \
 	read_parsers.o \
 	subset.o \
-	murmur3.o
+	kmer_filters.o \
+	assembler.o \
+	alphabets.o \
+	murmur3.o \
+	storage.o
 
 PRECOMILE_OBJS ?=
 PRECLEAN_TARGS ?=
@@ -250,9 +253,8 @@
 endif
 
 KHMER_HEADERS= \
-	counting.hh \
-	hashbits.hh \
 	hashtable.hh \
+	hllcounter.hh \
 	khmer_exception.hh \
 	khmer.hh \
 	kmer_hash.hh \
@@ -261,6 +263,10 @@
 	read_aligner.hh \
 	read_parsers.hh \
 	subset.hh \
+	kmer_filters.hh \
+	assembler.hh \
+	alphabets.hh \
+	storage.hh
 
 # START OF RULES #
