=== debian/changelog ===
khmer (2.1.1+dfsg-1) unstable; urgency=medium

  [ Andreas Tille ]
  * Remove empty field

  [ Michael R. Crusoe ]
  * New upstream version 2.1.1
  * Incorporate patch from Ubuntu, thank you Michael Hudson-Doyle.
    Closes: #862380

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Tue, 29 Aug 2017 23:30:09 -0700

khmer (2.0+dfsg-10ubuntu1) artful; urgency=medium

  * Fix build with Python 3.6.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Fri, 12 May 2017 13:15:00 +1200

khmer (2.0+dfsg-10) unstable; urgency=medium

  * Team upload.
  * Revert "Drop arm64 due to failing tests."  Closes: #859752

 -- Mattia Rizzolo <mattia@debian.org>  Thu, 06 Apr 2017 22:02:24 +0200

khmer (2.0+dfsg-9) unstable; urgency=medium

  * Drop arm64 due to failing tests. (Closes: #851830)

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Tue, 24 Jan 2017 07:37:50 -0800

khmer (2.0+dfsg-8) unstable; urgency=medium

  * Team upload.
  * Enable static building ('--static') with pkg-config.
  * Have autopkgtests use pkg-config.

 -- Sascha Steinbiss <satta@debian.org>  Sun, 15 Jan 2017 13:13:43 +0000

khmer (2.0+dfsg-7) unstable; urgency=medium

  * make build reproducible

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Mon, 23 May 2016 12:55:46 -0700

khmer (2.0+dfsg-6) unstable; urgency=medium

  * Switch from deprecated ruby-ronn to asciidoctor for manpage generation
  * Bump Standards-Version to 3.9.8

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Wed, 04 May 2016 11:25:30 -0700
