=== debian/control ===
--- 
+++ 
@@ -1,24 +1,26 @@
 Source: khmer
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Michael R. Crusoe <crusoe@ucdavis.edu>,
+Uploaders: Michael R. Crusoe <michael.crusoe@gmail.com>,
            Kevin Murray <spam@kdmurray.id.au>
 Section: science
 Priority: optional
 Build-Depends: debhelper (>= 9),
                dh-python,
                dh-exec,
+               python3-guzzle-sphinx-theme,
                python3 (>= 3.3),
                python3-dev (>= 3.3),
                python3-all-dev (>= 3.3),
                python3-setuptools (>= 3.3),
-               python3-screed,
-               python3-nose,
+               python3-screed (>= 1.0),
+               python3-pytest,
+               python3-pytest-runner,
                python3-sphinx,
                python3-sphinxcontrib.autoprogram,
                zlib1g-dev,
                libbz2-dev,
-               ruby-ronn
-Standards-Version: 3.9.6
+               asciidoctor
+Standards-Version: 4.0.0
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/khmer.git
 Vcs-Git: https://anonscm.debian.org/git/debian-med/khmer.git
 Homepage: http://khmer.readthedocs.org
@@ -43,7 +45,7 @@
 Multi-Arch: same
 Depends: khmer-common,
          python3 (>= 3.3),
-         python3-screed (<< 1.0),
+         python3-screed (>= 1.0),
          ${shlibs:Depends},
          ${misc:Depends},
          ${python3:Depends}
