=== debian/rules ===
--- 
+++ 
@@ -8,8 +8,6 @@
 export USE_SYSTEM_ZLIB=true
 export USE_SYSTEM_LIBBZ2=true
 
-export PACKAGE_VERSION := $(shell dpkg-parsechangelog | egrep '^Version:' | cut -f 2 -d ' ')
-
 export HOME=$(shell echo $$PWD"/fakehome")
 
 %:
@@ -19,16 +17,15 @@
 	dh_auto_build
 	ln -sf "`pwd`"/.pybuild/pythonX.Y_*/build/khmer/*.so khmer && \
 		./setup.py develop --user && ./setup.py build_sphinx
-	ronn -r --manual=khmer --organization='khmer project' \
-		debian/khmer.1.ronn
+	asciidoctor --backend manpage -a reproducible debian/khmer.1.adoc
 	cd lib && $(MAKE) clean all
 
 override_dh_auto_test:
 	dh_auto_install
 	PYBUILD_SYSTEM=custom \
 	    PYBUILD_TEST_ARGS="cd {dir}; export PATH={destdir}/usr/lib/khmer/bin:$$PATH ; \
-	    cd {build_dir}; {interpreter} -m nose --attr \
-	    '!known_failing,!jenkins,!huge'" dh_auto_test
+	    cd {build_dir}; export PYTHONPATH=$$(pwd); {interpreter} -m pytest \
+	    -m 'not known_failing and not jenkins and not huge'" dh_auto_test
 
 
 override_dh_auto_clean:
@@ -43,5 +40,8 @@
 	dh_install
 	find debian/khmer -name .gitignore -delete
 
+override_dh_sphinxdoc:
+	dh_sphinxdoc -X jquery.js
+
 get-orig-source:
 	uscan --verbose --force-download --repack --compression xz
